<template>
    <div>
        <div class="form-group">
            <label v-if="label !== ''" class="control-label">{{ label }}</label>
            <div class="row d-flex align-items-start">
                <div v-for="(image, index) in images" class="col-sm-6 pb-2">
                    <i class="fa fa-times-circle fa-lg btn-close btn-destroy-file float-right"
                            @click="removeFile(image, index)"></i>
                    <div class="w-100">
                        <img class="card-img-top" v-bind:src="image.storage_path" alt="">
                    </div>
                </div>
            </div>
            <hr class="divider"/>
            <div class="row d-flex align-items-end gallery-image-pickers" v-bind:class="{ 'is-invalid': errors[name] }">
                <div class="col-sm-6" v-for="(idx, index) in files" v-bind:key="idx">
                    <i class="fa fa-times-circle fa-lg btn-close float-right"
                            v-if="idx > 1" @click="removeFileTmp(idx)">
                    </i>
                    <div class="w-100">
                        <image-picker ref="imgPicker"
                            v-bind:data-ratio="ratio"
                            file-contents="image[]"
                            file-names="image_filename[]"
                            @imageAdded="imageAdded()">
                        </image-picker>
                        <span class="invalid-feedback" role="alert" v-if="errors[name + '.' + index +'.contents'] !== null" style="display:block">
                            <strong v-for="msg in errors[name + '.'+ index + '.contents']">{{ msg }}</strong>
                        </span>
                    </div>
                </div>
            </div>
            <button id="add-file" v-bind:disabled="disabledBtnAdd" type="button"
                    class="btn btn-outline-success" @click="addFile($event)">
                <i class="fa fa-plus"></i> Agregar imagen
            </button>
            <span class="invalid-feedback" role="alert" v-if="errors[name] !== null">
                <strong v-for="msg in errors[name]">{{ msg }}</strong>
            </span>
        </div>
    </div>
</template>

<script>
import ImagePicker from './ImagePicker.vue';
import utils from '../utils.js';

export default {
    components: {
        'image-picker': ImagePicker
    },
    data() {
        return {
            files: [1],
            images: [],
            deletedImages: [],
            index: 1,
            totalFilesSaved: 0,
            disabledBtnAdd: false
        };
    },
    props: {
        //url de la imagensrc of image
        filesLimit: {
            type: Number,
            default: 1
        },
        ratio: {
            type: String,
            default: 'free'
        },
        label: {
            type: String,
            default: ''
        },
        errors: {
            type: Object,
            default: {}
        },
        name: {
            type: String,
            default: 'image'
        }
    },
    // Actualizamos los datos de configuracion
    beforeMount() {
        this.totalFilesSaved = this.images.length;
    },
    mounted() {
        // Despues de cargar el componente validamos si tenemos espacio para agregar archivos temporales
        if (this.totalFilesSaved >= this.filesLimit) {
            this.disabledBtnAdd = true;
            this.files = [];
        }
    },
    methods: {
        reset(files, images) {
            this.files = files !== void 0 ? files : [];
            this.images = images !== void 0 ? images : [];
        },
        getNewImages() {
            var vm = this;
            var images = [];
            _.each(vm.$refs.imgPicker, function(ele) {
                if (ele.urlImage !== null) {
                    images.push({
                        name: ele.filename,
                        contents: ele.urlImage
                    });
                }
            });
            return images;
        },
        getDeletedImages() {
            return this.deletedImages;
        },
        // Valida si aun tenemos espacio para agregar mas archivos
        isDisabledBtnAdd() {
            if ((this.totalFilesSaved + this.files.length ) >= this.filesLimit) {
                this.disabledBtnAdd = true;
            } else {
                this.disabledBtnAdd = false;
            }
            return this.disabledBtnAdd;
        },
        // Agregar otr archivo temporal
        addFile(evt) {
            evt.preventDefault();
            if (this.isDisabledBtnAdd()) {
                return false;
            }
            this.files.push(++this.index);
            this.isDisabledBtnAdd();
        },
        // Despues de que se ha cargado una nueva imagen temporal
        imageAdded() {
            this.isDisabledBtnAdd();
        },
        // Eliminar un archivo temporal
        removeFileTmp(idx) {
            this.files.splice(this.files.indexOf(idx), 1);
            this.isDisabledBtnAdd();
        },
        // Eliminar un archivo de la BD
        removeFile(image, index) {
            var vm = this;
            utils.confirmationMessage({
                title: "Borrar imagen",
                msg: "¿Estás seguro de borrar la imagen seleccionada?",
                type: 'question',
                callback: function() {
                    vm.images.splice(index, 1);
                    vm.deletedImages.push(image.id);
                    vm.totalFilesSaved--;
                    vm.isDisabledBtnAdd();
                }
            });
        }
    }
};
</script>